#include <bits/stdc++.h>
#include <ext/rope>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_cxx;
using namespace __gnu_pbds;
using namespace std;

#define int long long
#define vi vector<int>
#define F first
#define S second
#define ld long double
#define pii pair<int, int>
#define pb push_back
#define mp make_pair
#define all(a) a.begin(), a.end()
#define sz(a) (int)(a.size())
#define SORT(a) sort(all(a))
#define inf (int)(1e18)
#define e 1e-7
#define rng(n) for(int yu = 0; yu < (int)(n); yu++)
#define rngi(i, n) for(int i = 0; i < (int)(n); i++)

template<typename T>
void print(T a)
{
    for(auto x : a) cout<<x<< ' ';
    cout<<'\n';
}


struct node
{
    int leaf; int sz;
    vi go;
    node() {go.resize(30); sz = 0; leaf = 0; }
};
vector<node> tre;
void add(string s, int pos)
{
    int v = 0;
    rngi(i, sz(s))
    {
        char c = s[i] - 'a';
        if(!tre[v].go[c])
        {
            tre[v].go[c] = tre.size();
            tre.pb(node());
        }
        v = tre[v].go[c];
    }
    tre[v].leaf = pos;
}
vi sz;
int dfs(int v)
{
    sz[v] = bool(tre[v].leaf);
    rngi(i, 30)
     if(tre[v].go[i])
        sz[v] += dfs(tre[v].go[i]);
    return sz[v];
}
int dfs2(int v, int x)
{
    int cnt = (bool)(tre[v].leaf);
    if(x == 1 && tre[v].leaf) return tre[v].leaf;
    for(int i =0; i < 30; i++)
        if(tre[v].go[i])
        {
            int to = tre[v].go[i];
            if(cnt + sz[to] >= x)
                return dfs2(to, x - cnt);
            cnt += sz[to];
        }
}
int get(string s, int x)
{
    int v = 0;
    rngi(i, sz(s))
    {
        char c = s[i] - 'a';
        if(!tre[v].go[c])
            return -1;
        v = tre[v].go[c];
    }
    if(x >= sz[v]) return -1;
    return dfs2(v, x);
}
signed main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false); srand(time(NULL));
    int n, m; cin >> n >> m;
    tre.pb(node());
    rngi(i, n)
    {
        string s; cin >> s;
        add(s, i + 1);
    }
    int k = sz(tre); sz.resize(k);
    dfs(0);
   // print(sz);
    rng(m)
    {
        int x; cin >> x;
        string s; cin >> s;
        cout << get(s, x) << '\n';
    }
    return 0;
}
