#include <iostream>
#include <vector>

using namespace std;

vector<int> dist_vec[100000];
vector<int> graph[100000];
int dist[100000];

void bfs(int u) {
    for (int i = 0; i < graph[u].size(); ++i) {
        dist[graph[u][i]] = max(dist[u] + 1, dist[graph[u][i]]);
        bfs(graph[u][i]);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    for (int i = 0; i < m; ++ i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        graph[a].push_back(b);
    }
    for (int i = 0; i < n; ++ i) {
        bfs(i);
        dist_vec[i].push_back(0);
        for (int j = i + 1; j < n; ++ j) {
            if (dist[j] == 0) {
                dist_vec[i].push_back(-1);
            } else {
                dist_vec[i].push_back(dist[j]);
                dist[j] = 0;
            }
        }
    }
    for (int  i = 0; i < q; ++ i) {
        int t, y, maxi = -1;
        cin >> t >> y;
        int a[y], cur_a = y - 1;
        t--;

        for (int j = 0; j < y; ++ j) {
            cin >> a[j];
            a[j] --;
        }
        while (a[cur_a] > t) {
            cur_a --;
        }
        for (int j = t; j > -1; -- j) {
            if (cur_a > -1 && a[cur_a] == j) {
                cur_a --;
                continue;
            }
            maxi = max(maxi, dist_vec[j][t - j]);

        }
        cout << maxi << endl;
    }
}
