#include<bits/stdc++.h>

using namespace std;

const int N = 1e5+1;

int n, m, q;
vector<int> g[N];

bool can[N];

int d[N];
int bfs(int s){
    for(int i = 0; i < n; ++i)
        d[i] = -1;
    d[s] = 0;
    queue<pair<int, int>> q;
    q.emplace(s, 0);
    int res = -1;
    while(!q.empty()){
        int v = q.front().first,
            w = q.front().second;
        q.pop();
        if(d[v] != w)
            continue;
        if(can[v])
            res = max(res, w);
        for(int u : g[v]){
            d[u] = max(d[u], d[v]+1);
            q.emplace(u, d[u]);
        }
    }
    return res;
}

int main(){
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    cin >> n >> m >> q;
    for(int i = 0; i < m; ++i){
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[v].push_back(u);
    }
    for(int i = 0; i < 1; ++i){
        int t, y;
        cin >> t >> y;
        --t;
        for(int i = 0; i < n; ++i)
            can[i] = true;
        for(int i = 0; i < y; ++i){
            int c;
            cin >> c;
            --c;
            can[c] = false;
        }
        cout << bfs(t) << '\n';
    }

}
